<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "city".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "City".
 *
 * Columns in table "city" available as properties of the model,
 * followed by relations of table "city" available as properties of the model.
 *
 * @property integer $id
 * @property integer $state_id
 * @property integer $is_pending_approval
 * @property string $name
 * @property string $friendly_url
 * @property integer $visits_number
 * @property string $region_id
 *
 * @property State $state
 * @property Location[] $locations
 */
abstract class BaseCity extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'city';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'City|Cities', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('state_id, name, friendly_url, region_id', 'required'),
            array('state_id, is_pending_approval, visits_number', 'numerical', 'integerOnly' => true),
            array('name', 'length', 'max' => 50),
            array('friendly_url', 'length', 'max' => 255),
            array('region_id', 'length', 'max' => 10),
            array('is_pending_approval, visits_number', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, state_id, is_pending_approval, name, friendly_url, visits_number, region_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'state' => array(self::BELONGS_TO, 'State', 'state_id'),
            'locations' => array(self::HAS_MANY, 'Location', 'city_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'state_id' => null,
            'is_pending_approval' => Yii::t('app', 'Is Pending Approval'),
            'name' => Yii::t('app', 'Name'),
            'friendly_url' => Yii::t('app', 'Friendly Url'),
            'visits_number' => Yii::t('app', 'Visits Number'),
            'region_id' => Yii::t('app', 'Region'),
            'state' => null,
            'locations' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('state_id', $this->state_id);
        $criteria->compare('is_pending_approval', $this->is_pending_approval);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('friendly_url', $this->friendly_url, true);
        $criteria->compare('visits_number', $this->visits_number);
        $criteria->compare('region_id', $this->region_id, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
